SystemOrganization addCategory: #'TP Integrador'!

Object subclass: #Condicion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

Condicion subclass: #Confundido
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Confundido methodsFor: 'as yet unclassified' stamp: 'juan 10/27/2013 02:10'!
tePodesMover 
^Moneda flip ifTrue:[^true]
ifFalse:[self teAutoGolpeas. ^false]. 

"El enunciado dice que si intenta moverse y no puede, recien ah se autogolpea cabeza, no que esta re duro y de una no se puede ni mover jaja. Ademas habiendo jugado una bocha de veces al gameboy calculo que quisieron ponerlo igual a como es en el jueguito posta: tira la moneda, si sale cara ataca todo bien, si sale seca se pega a el mismo el enfermito."! !

Condicion subclass: #Dormido
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Dormido methodsFor: 'as yet unclassified' stamp: 'juan 10/27/2013 02:08'!
tePodesMover 
^Moneda flip ifTrue:[self condicion:Normal. ^true. ]
ifFalse:[^false]. 

"le cambie el orden a la parte de ifTrue. Fijate que la version de antes no ponia al self en color (lo tomaba como nose, algo raro, y para separar sentencias (o sea si queres hacer varias cosas) se separan con un punto segun la guia de lenguajes. El and se usa nada mas para comparar booleanos)"! !

Condicion subclass: #Normal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Normal methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 20:20'!
tePodesMover
^true.! !

Condicion subclass: #Paralizado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Paralizado methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 20:49'!
tePodesMover 
Moneda flip ifTrue:[^true]
ifFalse:[^false].! !

Object subclass: #ErrorDebesDebilitarloMas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!ErrorDebesDebilitarloMas methodsFor: 'as yet unclassified' stamp: 'juan 10/26/2013 22:54'!
errorDebesDebilitarloMas

Error signal: 'Debes debilitar mas al pokemon para capturarlo!!'.! !

Object subclass: #EstePokemonYaTieneDuenioError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!EstePokemonYaTieneDuenioError methodsFor: 'as yet unclassified' stamp: 'juan 10/26/2013 22:55'!
estePokemonYaTieneDueoError

Error signal: 'No puedes robar este pokemon. Ya tiene dueo!!'! !

Object subclass: #Movimiento
	instanceVariableNames: 'usosDisponibles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Movimiento methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:11'!
estasDisponible
^usosDisponibles >0.! !

!Movimiento methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:14'!
unUsoMenos 
usosDisponibles:=usosDisponibles -1.! !

!Movimiento methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 18:49'!
usosDisponibles:unosUsos
usosDisponibles:=unosUsos. ! !

Movimiento subclass: #MovimientoCurativo
	instanceVariableNames: 'puntosDeVida puntosACurar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!MovimientoCurativo methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 18:36'!
aplicarEfectoA: otroPokemon
otroPokemon curate:puntosACurar.! !

!MovimientoCurativo methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 17:59'!
convieneQue:pokemonAtacante TeUseContra: pokemonAtacado
^(pokemonAtacante tusPuntosDeVida <= (pokemonAtacante tusPuntosDeVidaMax / 2)) and:[(pokemonAtacante tePuedenSacrificar)not]. 
! !

!MovimientoCurativo methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:35'!
cuantoPoderSumas 
^puntosACurar. ! !

!MovimientoCurativo methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:44'!
puntosACurar:unaCantidad
puntosACurar:=unaCantidad.! !

Movimiento subclass: #MovimientoDanino
	instanceVariableNames: 'puntosDeDao'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'juan 10/26/2013 22:54'!
aplicarEfectoA:otroPokemon
otroPokemon teDaaron:self puntosDeDao.

"Le puse un self adelante a puntosDeDao, sino quedaba en azul como si fuera una variable y no un atributo".! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'juan 10/27/2013 01:17'!
convieneQue:pokemonAtacante TeUseContra:pokemonAtacado
^(self derrotasPorMenosDe50A:pokemonAtacado| pokemonAtacante unicoDanino | self  sosElUnicoQueDerrotaA:pokemonAtacado| self noDerrotasA:pokemonAtacado). ! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:46'!
cuantoPoderSumas 
^puntosDeDao *2.! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'juan 10/27/2013 01:16'!
derrotasPorMenosDe50A:otroPokemon
^(self puntosDeDao - otroPokemon puntosDeVida ) abs <50. 

"Le agregue el abs (valor absoluto), porque si te fijas, si el ataque es de dao=30, y la vida que tiene el otro es 100 por ejemplo, el resultado es -70 (menor a 50), y en realidad no lo estara matando. Asi que le mande eso del valor absoluto (funcion modulo) para que si o si se cumpla que con el ataque: a) lo esta matando al otro flaco
									  b) lo esta matando con diferencia menor a 50."! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 18:47'!
noDerrotasA:unPokemon
^self puntosDeDao < unPokemon puntosDeVida. ! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 17:41'!
puntosDeDao 
^puntosDeDao. ! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:47'!
puntosDeDao:unaCantidad
puntosDeDao:=unaCantidad. ! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'juan 10/27/2013 01:24'!
sosElUnicoQueDerrotaA:unPokemon
^(self puntosDeDao >=50 and:[unPokemon movimientosDisponibles count:[:movimiento|movimiento class=MovimientoDanino and:[movimiento puntosDeDao > unPokemon puntosDeVida]]=1]). ! !

Movimiento subclass: #MovimientoEspecial
	instanceVariableNames: 'condicionAAplicar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

MovimientoEspecial subclass: #Confusion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Confusion methodsFor: 'as yet unclassified' stamp: 'juan 10/27/2013 02:12'!
aplicarEfectoA:otroPokemon
otroPokemon quedas:Confundido.

"Saqu el otroPokemon teAutoGolpeas porque cuando apenas lo confunden no se pega solo, nada ms se golpea a si mismo cuando quiere atacar y sale seca en la moneda"! !

!Confusion methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:21'!
cuantoPoderSumas 
^40. ! !

!MovimientoEspecial methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 17:59'!
convieneQue:pokemonAtacante TeUseContra:pokemonAtacado
^(pokemonAtacado cuantaGrositudTenes > (pokemonAtacante cuantaGrositudTenes *2)) and:[^pokemonAtacado condicion=Normal]. ! !

MovimientoEspecial subclass: #Paralisis
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Paralisis methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:15'!
aplicarEfectoA: otroPokemon
otroPokemon quedas:Paralizado.! !

!Paralisis methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:52'!
cuantoPoderSumas 
^30.! !

MovimientoEspecial subclass: #Suenio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Suenio methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:16'!
aplicarEfectoA: otroPokemon
otroPokemon quedas:Dormido.! !

!Suenio methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:52'!
cuantoPoderSumas 
^50. ! !

Object subclass: #NoTePodesMoverError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!NoTePodesMoverError methodsFor: 'as yet unclassified' stamp: 'juan 10/26/2013 23:01'!
noTePodesMoverError

Error signal: 'El pokemon no puede moverse!!'! !

Object subclass: #Objeto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

Objeto subclass: #Medicina
	instanceVariableNames: 'cantidadQueCura'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Medicina methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:34'!
aplicarEn:unPokemon
unPokemon curate:cantidadQueCura.! !

!Medicina methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:34'!
cantidadQueCura:unaCantidad
cantidadQueCura:=unaCantidad. ! !

Objeto subclass: #MedicinaEspecial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!MedicinaEspecial methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:35'!
aplicarEn:unPokemon
unPokemon condicion:Normal.! !

Objeto subclass: #Pokebola
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Pokebola methodsFor: 'as yet unclassified' stamp: 'juan 10/27/2013 00:27'!
aplicarEn:unPokemon yTelatiro:unEntrenador

unPokemon tusPuntosDeVida <= (unPokemon tusPuntosDeVidaMax / 2) ifFalse:[ErrorDebesDebilitarloMas signal].

unPokemon tieneEntrenador  ifTrue:[EstePokemonYaTieneDuenioError signal]
							     ifFalse:[unPokemon esDeAlguien:(ConEntrenador new).
										(unPokemon esDeAlguien) tuNuevoEntrenadorEs: unEntrenador.
										unPokemon pokemones add:unPokemon].


"Le saque un ^ que habia adelante de --> unPokemon tieneEntrenador "

"Le agregue un pokemones add:unPokemon asi va agregando a una coleccion cada pokemon que va teniendo entrenador (para hacer punto 6b)"! !

Object subclass: #Pokemon
	instanceVariableNames: 'movimientos puntosDeVida puntosDeVidaMax condicion experiencia ganadores movimientosDisponibles esDeAlguien'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

Pokemon subclass: #ConEntrenador
	instanceVariableNames: 'pokemonesConEntrenador entrenador'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!ConEntrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 21:37'!
entrenador
^entrenador.! !

!ConEntrenador methodsFor: 'as yet unclassified' stamp: 'juan 10/27/2013 00:58'!
initialize 
pokemonesConEntrenador:=Set new. ! !

!ConEntrenador methodsFor: 'as yet unclassified' stamp: 'juan 10/27/2013 00:58'!
pokemones
^pokemonesConEntrenador.

"Es el getter para saber todos los pokemones con entrenador. (Para hacer punto 6b)"! !

!ConEntrenador methodsFor: 'as yet unclassified' stamp: 'juan 10/27/2013 01:04'!
tePuedenSacrificar 
|unEntrenador|

unEntrenador:=self entrenador.

^(pokemonesConEntrenador count:[:unPokemon|(unPokemon entrenador=unEntrenador) and: (unPokemon podesLuchar)])>=2 and:[self cuantaGrositudTenes > (pokemonesConEntrenador collect:[:unPokemon|(unPokemon entrenador=unEntrenador) and: unPokemon cuantaGrositudTenes])max]. 

"A la coleccion pokemones le cambie el nombre a pokemonesConEntrenador (por lo que entendi creo que era eso, pero deje el significado mas claro con el nombre) "

"Le agregue la variable local unEntrenador, para que NADA MAS se cuenten todos los pokemones que tiene el entrenador del pokemon al que se le pregunta si se lo puede sacrificar. De esta forma se evita que la coleccion pokemones incluya a TODOS los pokemones de TODOS los entrenadores, no se si me explico. Capaz estaba bien hecho antes (sin la variable local), o capaz con esto nuevo que le puse se soluciona eso que jodia en los test. Miralo un toque con esto que te digo que despues lo vemos juntos si queres loca."! !

!ConEntrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:55'!
tieneEntrenador
^true.! !

!ConEntrenador methodsFor: 'as yet unclassified' stamp: 'juan 10/24/2013 20:57'!
tuNuevoEntrenadorEs:unEntrenador

entrenador:=unEntrenador.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 20:50'!
condicion
^condicion.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:11'!
condicion:unObjeto
condicion:=unObjeto. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/26/2013 23:34'!
cuantaGrositudTenes
^self nivel * self sumaPoderMovimientos. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:01'!
curate:unosPuntos
puntosDeVida:=puntosDeVida + (unosPuntos).! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 21:58'!
esDeAlguien 
^esDeAlguien. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/24/2013 21:00'!
esDeAlguien:unObjeto
esDeAlguien:=unObjeto! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 17:15'!
experiencia 
^experiencia. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:09'!
experiencia:unaCantidad
experiencia:=unaCantidad.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 21:04'!
initialize
movimientos:=Set new. 
movimientosDisponibles:=Set new. 
self condicion:Normal new.
ganadores:=Set new. 
self experiencia:0. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/27/2013 01:09'!
luchaCon:unMovimiento contra:otroPokemon
(self condicion)tePodesMover ifFalse:[NoTePodesMoverError signal].
self movimiento:unMovimiento contra:otroPokemon.
otroPokemon tusPuntosDeVida >=0 ifTrue:[ganadores add:self]
ifFalse:[self error:'No gano todavia'].  


"Le saque un ^ que habia adelante de otroPokemon tusPuntosDeVida porque creo que no hace falta que devuelva nada."

"Le cambie el signo de <=0 por un >=0 porque creo que ese renglon lo que quiere decir es que: si el pokemon ataca y lo deja al otro bicho en 0 o con algo de vida, que se lo agregue a la coleccion de ganadores, no?"

"El ifFalse:[self error: 'No gano todavia'] que carago es? jaja, o sea entiendo qu es, pero lo pide en algn lado del enunciado? Me parece que lo tengo como el orto jajaja despues acordate de contarme que onda."! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:13'!
movimiento:unMovimiento contra:otroPokemon
unMovimiento aplicarEfectoA:otroPokemon.
unMovimiento unUsoMenos. 
! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 20:28'!
movimientos
^movimientos.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 20:40'!
movimientos:unaColeccion
movimientos:=unaColeccion. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 17:17'!
movimientosConvenientesContra:otroPokemon
movimientosDisponibles select:[:movimiento|movimiento convieneQue:self TeUseContra:otroPokemon].! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 18:31'!
movimientosDisponibles
movimientosDisponibles:= self movimientos select:[:movimiento|movimiento estasDisponible]. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 19:51'!
nivel
^(experiencia nthRoot:7) floor. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 18:47'!
podesLuchar
^puntosDeVida >0.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/26/2013 23:41'!
premiaALosGanadores
(self tusPuntosDeVida) =0 ifTrue:[ganadores do:[:unPokemon|unPokemon salisteGanadorContra:self]].

"Le saque un ^ que habia adelante de todo"! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:16'!
quedas: unaCondicion
self condicion:unaCondicion.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/27/2013 01:07'!
salisteGanadorContra:unPokemon
|experienciaASumar|
experienciaASumar:=(unPokemon cuantaGrositudTenes / ganadores size). 
self tusPuntosDeVida >0 ifTrue:[self experiencia:(self experiencia +experienciaASumar)]. 

"Le saque un ^ que habia adelante de self tusPuntosDeVida porque creo que no es necesario devolver nada (acordate que con do no me importa lo que devuelve, sino que lo haga y nada mas (no importa el efecto creo que decian los ayudantes) )."! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 17:30'!
soloUnMovimientoLoDerrotaA:unPokemon 
^self puntosDeDao >=50 and:[self movimientosDisponibles count:[:movimiento|movimiento class=MovimientoDanino and:[movimiento puntosDeDao > unPokemon puntosDeVida]]=0]. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/26/2013 23:38'!
sumaPoderMovimientos 
^self movimientos sum:[:movimiento|movimiento cuantoPoderSumas]. 

"Le agregue un self adelante de movimientos, sino quedaba como que era una variable y en realidad es un atributo, creo"

! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/24/2013 23:41'!
teAutoGolpeas 
puntosDeVida:=(puntosDeVida -30 max:0). ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:02'!
teDaaron:unosPuntos
puntosDeVida:=(puntosDeVida-unosPuntos max:0) . ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/23/2013 00:15'!
tusPuntosDeVida
^puntosDeVida.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 18:48'!
tusPuntosDeVida:unosPuntos
puntosDeVida:=unosPuntos. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/23/2013 00:19'!
tusPuntosDeVidaMax
^puntosDeVidaMax.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 18:48'!
tusPuntosDeVidaMax:unosPuntos
puntosDeVidaMax:=unosPuntos. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/25/2013 17:58'!
unicoDanino 
^((self movimientosDisponibles) count:[:movimiento|movimiento class=MovimientoDanino])=1! !

Pokemon subclass: #SinEntrenador
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!SinEntrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:19'!
tePuedenSacrificar 
^false.! !

!SinEntrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:55'!
tieneEntrenador
^false.! !
